

//POJlib.js
//Stellt das JS-Objekt zur verfgung, 
//welches die Daten hlt und den Programmcode ausfhrt
// Enthlt jegliche Logik zur Darstellung und Ausfhrung der Anwendung

var oChart = new Object();


oChart.LoadOptions = function()
{
    /////////////////////////////////////////////////////////////
    ///Member/Default-Parameter setzen
    
    //JS-ID des Divs, in dem das chart dargestellt wird
    oChart.ChartDivID = 'chart_div';
    oChart.TableDivID = 'table_div';
    oChart.TitleID    =  'TitleText';
    oChart.btnStartID = 'b1';
    oChart.btnStopID  = 'b2';
    oChart.CharacteristicValueLegendID  = 'CharacteristicValueText';

    oChart.TitleColor = '#66747F';
    oChart.TextColor =  '#6C6F68';
    
       
    
    //Zeitperiode aus der die Daten geholt und Dargestellt werden
    //sollen
    if(oChart.TimeSpanInDays == null || !(oChart.TimeSpanInDays % 1 === 0))
    {//Nicht gesetzt, oder kein Integer
      oChart.TimeSpanInDays = 14;    
    }
    else
    {//Daten drfen nicht lnger als 30 Tage zurckliegen
        if(oChart.TimeSpanInDays > 30)
            oChart.TimeSpanInDays = 30;
    }
      
    
    
    //Berechnen der Datumsangaben im Title
    
    oChart.EndDate = new Date();
    oChart.EndDate = oChart.EndDate.getDate() +"." 
                    + oChart.LeadingZero(oChart.EndDate.getMonth()+1) +"."
                    +oChart.EndDate.getFullYear();
    
     oChart.StartDate = new Date();
     oChart.StartDate.setDate(oChart.StartDate.getDate() - oChart.TimeSpanInDays )
     
     oChart.StartDate = oChart.StartDate.getDate() +"."
                    +oChart.LeadingZero(oChart.StartDate.getMonth()+1) +"."
                    +oChart.StartDate.getFullYear(); 
                    
    
    document.getElementById(oChart.TitleID ).innerHTML = "Verlauf der Wasserstnde des Rheins vom " + oChart.StartDate + " bis " + oChart.EndDate;
    
    //Diagramm-Optionen 
    oChart.options = {  
        //Globale Einstellungen   
        fontName: 'Arial',
        
        titleTextStyle :{
            color: oChart.TitleColor,
            fontSize : 27
        },
    
        //Title wird in einem externen HTML-Div verwaltet 
        titlePosition : 'none',

        
        //HTML fr Tooltip aktivieren --> berschrift FETT
        tooltip: {isHtml: true},
        
        //Animation beim auswechseln der Daten
        animation:{
            duration: 200,
            easing: 'linear'
        },
        
        //Gre des eigentlichen Diagramms im DIV
        chartArea:{
            width : "100%",
            height : "100%",
            top : "10%",
            left :"0%"
    
       
        },
    
        //Formatieren der Datenreihen:
            //Charakteristische Daten  als Offset --> Rote Linie
            //Eigentliche Messwerte als verbundene Balken in Blau
        series: [{color :'red',areaOpacity : 0},{color:'#195ca3'}],
    
        //Formatieren der Y-Achse
        vAxis:{   
            textPosition : 'none',
            viewWindow:{
             viewWindowMode:'explicit',
             //Werte fr Minimum und Maximum vorerst nicht von bedeutung
             //Werden spter durch den Code Dynamisch angepasst anhand der
             //Messwerte
             min :  0,
             max : 100
          }
        }, 
        
        //Formatieren der X-Achse
        hAxis:
        {  
            textPosition: 'in',
            allowContainerBoundaryTextCufoff :'true',
            //Jede 2. Beschriftung wird angezeigt
            showTextEvery:2,
            textStyle:{
                color: oChart.TextColor,
                fontSize:14
            }
        
            
        } 
    
    };
    
    //Zhler fr das Umschalten der Messdaten
    oChart.iRowCount = 0;
    
    //Stop-Flag zum unterbrechen der Animation
    oChart.bStopAni = false;
    
    //Luft die Animation akutell?
    oChart.bAnimationRunning = false;
    
    //Woran soll sich die Darstellung Orientieren?
    if(oChart.OffsetMode == null)
    {
        oChart.OffsetMode ="MW";
    }

    
    //Beschriftung einfgen
    if(oChart.OffsetModeLong == null)
    {
      oChart.OffsetModeLong = "Mittleres Hochwasser";  
    }
    
    //extern erstellte Legende beschriften
    document.getElementById(oChart.CharacteristicValueLegendID ).innerHTML = oChart.OffsetModeLong; 
    
    
    //Welches Gewsser soll dargestellt werden?
    oChart.Water = "Rhein";
    //Pegel Darstellungs-Offset
    //Der  Wert wird nach der Datenbernahme berechnet, sodass kein Pegel
    //unterhalb der X-Achse gelangen kann
    oChart.iOffset = 0;
    
    
    //Deklarieren der Buttons um sicher gehen das sie
    //vorhanden sind.
    oChart.button_start = document.getElementById(oChart.btnStartID);
    oChart.button_stop = document.getElementById(oChart.btnStopID);
    
    //Deklarieren der Chart-Daten und Darstellung um sicher zu gehen,
    //das Sie vorhanden sind
    oChart.data = null;
    oChart.chart = null;
    
    
    //Deklarieren der Messdaten um sicher zu gehen,
    //das Sie vorhanden sind    
    oChart.Messdaten = null;

}





////////////////////////////////////////////////////////////////
//Methoden


oChart.init = function()
{//Initialisiert die Darstellung des Diagramms
//Jegliche Vernderung an den Parametern muss vor der ersten 
//Ausfhrung dieser Funktion erfolgen

    
    // Datentabelle
    oChart.data = new google.visualization.DataTable();

    // Erstellen des Visualierungsobjektes
    oChart.chart = new google.visualization.SteppedAreaChart(document.getElementById(oChart.ChartDivID));

    //Initialisieren der Buttons/bergabe in den Code
    oChart.button_start = document.getElementById(oChart.btnStartID);
    oChart.button_stop = document.getElementById(oChart.btnStopID);


    //Messdaten von Pegel Online einlesen
    oChart.Messdaten = oChart.fillData();

    //Maximumwert der Y-Achse setzen
    oChart.SetMaxAxisValues()
    
    //Tabelle vorbereiten/Tabellenkopf
        //Messstelle
    oChart.data.addColumn('string','Messtelle');
        //Welche Characteristische Werte dienen als Orientierung
    oChart.data.addColumn('number',oChart.OffsetModeLong);
        //Tooltip fr den Characteristischen Wert  
    oChart.data.addColumn({type: 'string', role: 'tooltip', 'p': {'html': true}});
        //Pegelwert
    oChart.data.addColumn('number','gemessener Wassserstand');
        //Tooltip fr den Pegelwert
    oChart.data.addColumn({type: 'string', role: 'tooltip', 'p': {'html': true}});
    
    
    //Daten initial in das Diagramm laden
    for(var i = 0; i<oChart.Messdaten[0].length;i++)
    {//Fr jede verfgbare Station
        //Hinzufgen der Zeile zu dem DatenArray
        oChart.data.addRow([oChart.Messdaten[0][i][1],//Name der Station
                            oChart.iOffset,//Offset, immer gleich (Orientierung)
                            '<b>'+oChart.OffsetModeLong+'</b>', // Text fr den Tooltip
                            // Normalisierter Pegelwert
                            oChart.Messdaten[0][i][2]-
                            oChart.Messdaten[0][i][3]+
                            oChart.iOffset,//
                            //Tooltip fr den Pegelwert
                            "<b>"+oChart.Messdaten[0][i][1]+ //Name der Messtelle
                            ":</b><br />Wasserstand: "+oChart.Messdaten[0][i][2]+ //Pegelwert
                            " cm<br />"+oChart.OffsetModeLong+": " + // Name der Characteristischen Werte 
                            oChart.Messdaten[0][i][3]+" cm"] ) ;//Wert
    }

    
    var oDate = oChart.toDate(oChart.Messdaten[0][0][0]);
    //Aktualisieren des Zeitpunktes:
    document.getElementById(oChart.TableDivID).innerHTML = oChart.LeadingZero(oDate.getDate())+"."+oChart.LeadingZero(oDate.getMonth()+1)+"."+oChart.LeadingZero(oDate.getFullYear())+ 
    "&nbsp;&nbsp;" + oChart.LeadingZero(oDate.getHours()) +":"+ oChart.LeadingZero(oDate.getMinutes()) ;

    //Eventhandler fr die onclick-Methoden der Buttons                                  
    oChart.button_start.onclick = oChart.StartAnimation;
    oChart.button_stop.onclick = oChart.StopAnimation;

    //Neuzeichnen des Diagramms beim verndern der Bildschirmgre
    //und des Zoom-Levels
    window.onresize = function() {
        oChart.drawChart();
    }
    
    //Erstellen und Verwalten des Timeline-Sliders
    oChart.handleSlider();
    

    //Initiales Zeichnen des Graphen
    oChart.drawChart();
    


}  
 
 
/////////////////////////////////////////////////////////////////////
/////getJSON()
///Funktion: Lscht die die Aktuelle Datenzeile (Je Zeiteinheit)
//und fgt die nchste ein. Dies geschieht in einer Endlosschleife
///Parameter: 
//(String) searchstring
///Rckgabewert:
//Ein geparstes JSON Objekt    
oChart.getJSON = function(searchstring)
{
    var url = "http://www.pegelonline.wsv.de/webservices/rest-api/v2/"+ searchstring ;
    var xmlHttp = null;
    var jsonobj = null;

    xmlHttp = new XMLHttpRequest();
    xmlHttp.open( "GET", url, false );
    xmlHttp.send( null );

    //Der JSON String wird in ein Objekt geparsed
    jsonobj = eval(xmlHttp.responseText);

    return jsonobj;
}
            
/////////////////////////////////////////////////////////////////////
/////AnimateRows()
///Funktion: Lscht die die Aktuelle Datenzeile (Je Zeiteinheit)
//und fgt die nchste ein. Dies geschieht rekursiv in einer Endlos
//Schleife und kann durch setzen eines Flags unterbrochen werden
///Parameter:
//bAnimation - bestimmt ob die Funktion rekursiv ausgefhrt wird

oChart.AnimateRows = function(bAnimation){
	//Reihen aus Datenarry lschen Lschen
	for(var x = 0; x<oChart.Messdaten[0].length;x++)
	{
	   oChart.data.removeRow(0);
	}
                                                            
	//Reihen Hinzufgen                           
	for(var i = 0; i<oChart.Messdaten[0].length;i++)
	{
	   oChart.data.addRow([oChart.Messdaten[oChart.iRowCount][i][1],//Name der Station
                        oChart.iOffset,//Offset, immer gleich (Orientierung)
                        '<b>'+oChart.OffsetModeLong+'</b>',// Text fr den Tooltip
                        // Normalisierter Pegelwert
                        oChart.Messdaten[oChart.iRowCount][i][2]
                        -oChart.Messdaten[oChart.iRowCount][i][3]
                        +oChart.iOffset,
                        //Tooltip fr den Pegelwert
                        "<b>"+oChart.Messdaten[oChart.iRowCount][i][1]
                        +"</b><br />Wasserstand: "
                        +oChart.Messdaten[oChart.iRowCount][i][2]
                        +" cm<br />"+oChart.OffsetMode+": " 
                        + oChart.Messdaten[oChart.iRowCount][i][3]
                        +" cm" ] ) ;    	
    }     

    //UTC-String in Datum konvertieren
    var oDate = oChart.toDate(oChart.Messdaten[oChart.iRowCount][0][0]);


    //Aktualisieren des Zeitpunktes:
    document.getElementById(oChart.TableDivID).innerHTML = oChart.LeadingZero(oDate.getDate())+"."+oChart.LeadingZero(oDate.getMonth()+1)+"."+oChart.LeadingZero(oDate.getFullYear())+
    "&nbsp;&nbsp;" + oChart.LeadingZero(oDate.getHours()) +":"+ oChart.LeadingZero(oDate.getMinutes()) ;
    //Neuzeichnen des Diagramms
    oChart.drawChart();
    
      
    if(bAnimation)
    {//Rekursive Animation erwnscht
        oChart.bAnimationRunning = true;
        //Selbstaufruf mit leichter verzgerung
        window.setTimeout( oChart.Play, 100);   
    }
    else
    {
        oChart.bAnimationRunning = false;
    }
	
}
/////////////////////////////////////////////////////////////////////
/////StartAnimation()
///Funktion:Initiiert die Animation
///Parameter:
//Keine

oChart.StartAnimation = function()
{
    if(oChart.button_start.innerHTML == "Start")
    {
        oChart.button_start.innerHTML = "Pause";
        oChart.iRowCount =  $( "#slider" ).slider( "value" );
        oChart.bStopAni = false;
        oChart.Play();
    }
    else
    {
       oChart.PauseAnimation(); 
    }
  
}

/////////////////////////////////////////////////////////////////////
/////StopAnimation()
///Funktion:Startetund unterbricht die Ausfhrung der Animation
//indirekt recursiver Aufruf durch AnimateRows()
///Parameter:
//Keine
oChart.Play = function()
{

    
    if(oChart.bStopAni == false)
    {  
       
        oChart.iRowCount = oChart.iRowCount + 1;
        
        //Position des Sliders updaten
        $( "#slider" ).slider( "option", "value",oChart.iRowCount  );
    
        if(oChart.iRowCount >= oChart.Messdaten.length - 4  )
        {
            oChart.iRowCount =0;
            oChart.StopAnimation();
        }
        else
        {
         oChart.AnimateRows(true);   
        }
        
    }
    else
    {
      oChart.bStopAni = false;
      //Optisches Zurcksetzen des Diagramms;
      oChart.AnimateRows(false);  
    }
    
}

/////////////////////////////////////////////////////////////////////
/////NextDataSet()
///Funktion:Ruft nchsten Datensatz ab und pausiert die animaiton
///Parameter:
//Keine
oChart.NextDataSet = function()
{
    if(oChart.bAnimationRunning)
    {
         oChart.PauseAnimation();
    }
    oChart.iRowCount = oChart.iRowCount + 1 ;
    
    if(oChart.iRowCount == oChart.Messdaten.length - 4  )
    {
        oChart.iRowCount =0;
    }  
    
    oChart.AnimateRows(false);
    //Position des Sliders updaten
    $( "#slider" ).slider( "option", "value",oChart.iRowCount  );
}

/////////////////////////////////////////////////////////////////////
/////PrevDataSet()
///Funktion:Ruft vorherigen Datensatz ab und pausiert die animaiton
///Parameter:
//Keine
oChart.PrevDataSet = function()
{
    if(oChart.bAnimationRunning)
    {
         oChart.PauseAnimation();
    }

    oChart.iRowCount = oChart.iRowCount - 1;

    if(oChart.iRowCount == -1  )
    {
        oChart.iRowCount =oChart.Messdaten.length -4;
    }

    oChart.AnimateRows(false);
    //Position des Sliders updaten
    $( "#slider" ).slider( "option", "value",oChart.iRowCount  );
}


/////////////////////////////////////////////////////////////////////
/////StopAnimation()
///Funktion:Setzt Flags und beendet somit die Ausfhrung der Animation
// Und setzt den Zhlerstand auf 0
///Parameter:
//Keine
oChart.StopAnimation = function()
{

    
    oChart.iRowCount = 0;
    oChart.bStopAni = true;
    
    //Position des Sliders updaten
    $( "#slider" ).slider( "option", "value",oChart.iRowCount  );
    oChart.button_start.innerHTML = "Start";
    oChart.AnimateRows(false);
    
}

/////////////////////////////////////////////////////////////////////
/////PauseAnimation()
///Funktion:Setzt Flags und beendet somit die Ausfhrung der Animation
///Parameter:
//Keine
oChart.PauseAnimation = function()
{
    oChart.bStopAni = true;
    oChart.button_start.innerHTML = "Start";

}  

/////////////////////////////////////////////////////////////////////
/////FillData()
///Funktion:Holt die Messdaten von PEGEL ONLINE per REST-API
//Erzeugt Array mit Daten und gibt dieses zurck
///Parameter:
//Keine
///Rckgabewert:
//Array mit Mess Daten
oChart.fillData = function()
{
    //Daten per JSON von PEGEL ONINE holen

    //Die verfgbaren Stationen holen
    var oStations = oChart.getJSON("stations.json?waters=" + oChart.Water+"&includeTimeseries=true&includeCharacteristicValues=true");
    var MeasureData = new Array();
    var lclcounter =  0;
    var MinVal = 0;
 
 
    //Wieviele Stationen mit hinterlegten verwendeten! Characteristischen eigentschaften gibt es?
    for(var z = 0; z<oStations.length;z++)
    {
       if(oStations[z].timeseries[0].characteristicValues.length >0)
       {
           for(var u = 0; u < oStations[z].timeseries[0].characteristicValues.length;u++)
           {
                if(oStations[z].timeseries[0].characteristicValues[u].shortname == oChart.OffsetMode)
                {
                
                  lclcounter++; 
                }
           }     
       }
       
    }
    
    //Das Array Initialisieren
    for(var i = 0; i<(oChart.TimeSpanInDays*12);i++)
    {//Fr jede Uhrzeit = Zeile
        MeasureData[i] = new Array();
        for(var z = 0; z<lclcounter;z++)
        {//Jede Station
            MeasureData[i][z] = new Array();


            MeasureData[i][z][2] = 0;

        }
    }
    
    //Befllen der Daten 
    lclcounter = 0;         
    for(var z = 0; z<oStations.length;z++)
    {
       if(oStations[z].timeseries[0].characteristicValues.length >0 )
       {
           var iOrientation = null;
           for(var u = 0; u < oStations[z].timeseries[0].characteristicValues.length;u++)
           {
                if(oStations[z].timeseries[0].characteristicValues[u].shortname == oChart.OffsetMode)
                {
                  iOrientation = oStations[z].timeseries[0].characteristicValues[u].value;  
                }     
           } 
           if(iOrientation > 0)
           {
                oTempMeasurements = oChart.getJSON("stations/"+ oStations[z].uuid +"/W/measurements.json?start=P"+oChart.TimeSpanInDays+"D");
               for(var i= 0 ; i< oTempMeasurements.length;i += 8)
               {
                    //Ermitteln des Minimalen Wertes, zur Offsetermittlung
                    if((oTempMeasurements[i].value - iOrientation) < MinVal )
                    {
                      MinVal = oTempMeasurements[i].value - iOrientation;   
                    }
               
                    MeasureData[i/8][lclcounter][0] = oTempMeasurements[i].timestamp; // Zeitpunkt
                    MeasureData[i/8][lclcounter][1] = oStations[z].longname; //Name der Station
                    MeasureData[i/8][lclcounter][2] = oTempMeasurements[i].value;// Messwert                       
                    MeasureData[i/8][lclcounter][3] = iOrientation; //Bezugswert  
                    
                }
                lclcounter ++;
           }

        }                   
    }
 
    //Festlegen des Offsets, sodas die Pegel niemals unter der Y-Achse liegen knnen
    
    oChart.iOffset = 50+ (MinVal * (-1)); 
     return MeasureData;
}


/////////////////////////////////////////////////////////////////////
/////StopAnimation()
///Funktion:berechnet die Maximale Hhe der X-Achse und setzt den Wert
///Parameter:
//Keine
///Rckgabewert:
//keine
oChart.SetMaxAxisValues = function()
{
    var tMax = oChart.iOffset;
    for(var i = 0;i<oChart.Messdaten.length;i++)
    {
        for(var z=0;z<oChart.Messdaten[i].length;z++)
        {
            if((oChart.Messdaten[i][z][2]-oChart.Messdaten[i][z][3]+
                            oChart.iOffset) > tMax)
                tMax = (oChart.Messdaten[i][z][2]-oChart.Messdaten[i][z][3]+
                            oChart.iOffset);
        }
    }  
    
    oChart.options.vAxis.viewWindow.max = tMax; 
}

oChart.drawChart = function() 
{
  // Disabling the button while the chart is drawing.

  oChart.chart.draw(oChart.data, oChart.options);

}

oChart.handleSlider = function()
{
    //Den Slider verwalten:
    //Slider erstellen mit JQuery:
    $( "#slider" ).slider({
        slide: function( event, ui ) {}
    },{ min: 0 },{ max: oChart.TimeSpanInDays*12 });

    $( "#slider" ).on( "slide", function( event, ui ) {
    //Was geschieht beim Sliden

        oChart.PauseAnimation();
        
        oChart.AnimateRows();
        oChart.iRowCount =  $( "#slider" ).slider( "value" );
    } );
}

oChart.LeadingZero = function(NumberValue)
{
    if(NumberValue <10)
        return "0"+NumberValue;
    
    return NumberValue;
    
}

oChart.toDate = function(DateString)
{// Konvertiert einen Datumsstring zu eine Datumsobjekt
//  String sollte im UTC-Format sein
    DateString =  DateString.split("+")[0];
    DateString = DateString.split("T");
    
    var TimeString = DateString[1];
    TimeString = TimeString.split(":");
    DateString = DateString[0].split("-");

    return new Date(parseInt(DateString[0]),parseInt(DateString[1])-1,parseInt(DateString[2]),parseInt(TimeString[0]),parseInt(TimeString[1]),parseInt(TimeString[2]));
    
}